      program vibent
!
!       Standalone program for evaluation of phonon contribution to
!       - free energy  and
!       - entropy. 
!       Reads the .bands file generated by "Vibra",
!       removes three (q=0,omega=0) nodes,
!       makes a run over several temperature values.
!
!       Written by A. Postnikov, andrei.postnikov@univ-lorraine.fr
!
      implicit none
      integer ii1,io1,if,it
      parameter (ii1=11,io1=14)
      integer ialloc,ierr,nuo,nspin,nk
      double precision dum,path,tol,fmin,fmax,
     .       ff,ss,tt
      double precision, allocatable :: freq(:)
      parameter (tol=1.0E-8)
      character inpfil*60,outfil*60
      external fs_int1
!
! --- read frequencies (assuming we deal with a discrete spectrum
!     of a large supercell)
      write (6,"(' Specify name of .bands file (from Vibra): ')",
     .       advance="no")
      read (5,*) inpfil
      write (6,"(' ')")
      open (ii1,file=inpfil(1:len_trim(inpfil)),form='formatted',
     .      status='old',err=801)
      read (ii1,*) dum  !   ef/eV, no meaning for vibrations
      read (ii1,*) dum,path
      if (abs(path).gt.tol) then
        write (6,*) ' Non-zero path in 2d line; is it a q=0 spectrum?'
        stop
      endif
      read (ii1,*) fmin,fmax  !  frequency limits (in eV)
      read (ii1,*) nuo,nspin,nk
      if  ((nspin.ne.1).or.(nk.ne.1) ) then
        write (6,*) ' Strange numbers in the 4th line: ',
     .                nuo,nspin,nk
        stop
      endif
      allocate (freq(nuo),STAT=ialloc)
      if (ialloc.ne.0) then
        write (6,*) ' Fails to allocate space for ',nuo,' frequencies.'
        stop
      endif
      read (ii1,201,err=802,end=803) path,(freq(if),if=1,nuo)
      if (abs(path).gt.tol) then
        write (6,*) ' Non-zero q abscissa; is it a q=0 spectrum?'
        stop
      endif
      close (ii1)
      open (io1,file='RESULTS',form='formatted')
      write (io1,301)

      do it=1,50       !   Loop over temperature
        tt=it*20.0     !   
        call fs_int1(nuo,freq,tt,ff,ss)
        write (io1,302) tt,ff,ss
      enddo
      close (io1)

      stop

  201 format(f10.6,10f12.4,/,(10x,10f12.4))
  301 format('#  Temp (K)     Free Ene (eV)    Entropy (meV/K) ')
  302 format(f10.3,f17.8,f18.8)
  801 write (6,*) ' Error opening input file ',
     .            inpfil(1:len_trim(inpfil)),' as old formatted'
      stop
  802 write (6,*) ' Error reading frequencies'
      stop
  803 write (6,*) ' Unexpected end of file reading frequencies'
      stop

      end
!
!-------------------------------------------------------------------
!
      subroutine fs_int1(nuo,freq,tt,ff,ss)
!
!     Calculates free energy and entropy of vibrations, 
!     calculated for a discrete phonon spectrum
!     Input 
!       nuo          : number of discrete frequencies in the spectrum
!       freq(1..nuo) : frequencies of modes in cm-1
!       tt           : temperature in Kelvin
!     Output
!       ff         : free energy in eV
!       ss         : entropy in meV/K
 
      implicit none
      integer nuo,iff
      double precision tt,freq(nuo),ff,ss,xx,tol,fac_x,fac_f
!     [h-bar*w(inv.cm)]/[k_B*T(Kelvin)]*fac_x  -> yields unitless 
      parameter (fac_x=1.4387769) 
!     see my notes: this is 
!       [ 64.652976/521.461464 meV/cm-1 ]/[8.617332*10-2 meV/K (=k_B) ] 
      parameter (fac_f=8.617332478d-2)  ! Boltzmann konstant in meV/K
      parameter (tol = 1.0d-3) ! to recognize moe as w=0 one, and discard

      ff = 0.d0
      ss = 0.d0
      lf: do iff = 1,nuo
        if (abs(freq(iff)).lt.tol) cycle lf ! acoustic w=0 mode; ignore
        if (freq(iff).lt.0.) then
          write(6,"(' Imaginary frequency: ',e13.6,' ; ignored...')")
     .          freq(iff)
          cycle lf
        endif
        xx = freq(iff)/tt*fac_x
!       write(6,*) ' xx,sinh(xx),exp(xx),exp(-xx)=',
!    .        xx,sinh(xx),exp(xx),exp(-xx)
        ff = ff + log(2.0*sinh(xx/2.0))
        ss = ss + xx/(exp(xx)-1.0)-log(1.0-exp(-xx))
      enddo lf
      ff = ff*fac_f*tt*1.0d-3 !  Free energy in eV
      ss = ss*fac_f           !  Entropy in meV/K

      return
      end
